/*
 * BitmapImage.h
 *
 */

#ifndef BITMAPIMAGE_H_
#define BITMAPIMAGE_H_

#include "RGBPixel.h"

class BitmapImage {
public:
	BitmapImage(int w, int h); // TODO check that w and h are >0. Minimum image size is 1x1
	BitmapImage(const BitmapImage& bm); // TODO implement a copy constructor
	virtual ~BitmapImage(); // TODO avoid memory leaks

	void setPixel(int x, int y, const RGBPixel& value);
	RGBPixel getPixel(int x, int y) const; // TODO: getting pixels outside of image return a RGBPixel with values (-1, -1, -1)

	bool operator==(const BitmapImage& rh); // TODO: implement
	BitmapImage& operator=(const BitmapImage& rh); // TODO implement an assignment operator

	int getWidth() const {
		return width;
	}
	int getHeight() const {
		return height;
	}

protected:
	int width, height;
	RGBPixel* bitmap;
};

#endif /* BITMAPIMAGE_H_ */
